# utils.py

import globals as glob
import data

#########################################
def ChangeRoom( collidedToExitGateId ):
    exitTiles = glob.roomParameters[glob.roomIndex][2]
    for t in exitTiles:
        if(t[0] == collidedToExitGateId):
            
            ### Change room
            
            glob.roomIndex = t[1]
            newX = t[2]
            newY = t[3]
            
            # Set hero pos
            if(newX!=-999):
                glob.heroGob.wx = newX
            if(newY!=-999):
                glob.heroGob.wx = newY
                
             # Reset room
            ResetRoom(glob.roomIndex)

            # Change music
            newBgMusic = "rap2h.raw"
            if(glob.roomIndex==6):
                newBgMusic = "danger.raw"
            if(glob.currentBgMusic!=newBgMusic):
                glob.currentBgMusic=newBgMusic
                print("play:", glob.currentBgMusic)
                
                # Stop music after a while
                #if(glob.currentBgMusic =="danger.raw"):
                #    glob.timedEventList.append([glob.currentFrameTime + 9000, glob.TIMED_EVENT_STOP_MUSIC])
                #    glob.timedEventList.sort(key=glob.TimedEventSortFunc)
                
                if(isEmulator==False):
                    glob.sound.play_from_sd(glob.currentBgMusic)
                        
            break

#########################################
def ResetRoom(roomIndex):
    
    print("ResetRoom. roomIndex", roomIndex)
    
    tileParameters = glob.roomParameters[roomIndex][1]
    sprites = glob.roomParameters[roomIndex][3]
    
    ChangeTilemap(data.worldMaps[roomIndex], tileParameters)
    glob.test += 1
    
    for i in range(glob.ENEMIES_MAX_COUNT):
        #glob.roomParameters[roomIndex][0] is the room name
        gobIndex=i
        #print("enemy", i)
        enemy = glob.all_enemies_list[gobIndex]
        enemyCountInThisRoom = len(sprites)
        if( i >= enemyCountInThisRoom):
        #if(gobParams == []):
            enemy.wx = -999
            enemy.rect.x = -999
            enemy.active = False
        else:
            gobParams = sprites[gobIndex]
            #print("gobParams", gobParams)
            #print("gobParams[0]", gobParams[0])
            enemy.active = True
            enemy.frames = gobParams[0]
            enemy.frameOffsets = gobParams[1]
            enemy.wx = gobParams[2][0] 
            enemy.wy = gobParams[2][1] 
            enemy.vx = gobParams[2][2]
            enemy.vy = gobParams[2][3]
            enemy.animDur = gobParams[2][4]
            enemy.dir = gobParams[2][5]
            enemy.moveDelay = gobParams[2][6]
            enemy.bounceLimits[0] = gobParams[2][7]
            enemy.bounceLimits[1] = gobParams[2][8]
            enemy.bounceLimits[2] = gobParams[2][9]
            enemy.bounceLimits[3] = gobParams[2][10] 
            enemy.bounceType = gobParams[2][11]
            enemy.hmirror = gobParams[2][12]
            enemy.vmirror = gobParams[2][13]
            enemy.isCoin = gobParams[2][14]
            enemy.currentAnimFrameNum = 0;
            enemy.UpdateImage()
            enemy.animDurCounter = enemy.animDur;
            enemy.moveDelayCounter = 0
       
       
#########################################
def ChangeTilemap(tilemap, tileParameters):

    # Copy tilemap data
    for i in range(len(tilemap)):  #(18*14): # 252
        data.ramMapPixels[i] = tilemap[i]

    # Set tile attributes and bitmaps
    for i in range(len(tileParameters)):
        tileId = tileParameters[i][0]
        glob.tileAttributeArray[tileId] = tileParameters[i][2]
        glob.tilemap.set_tile(tileId, 8, 8, tileParameters[i][1])


